'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Edge = function (_Component) {
    _inherits(Edge, _Component);

    function Edge() {
        _classCallCheck(this, Edge);

        return _possibleConstructorReturn(this, (Edge.__proto__ || Object.getPrototypeOf(Edge)).apply(this, arguments));
    }

    _createClass(Edge, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            return this.props.edge !== nextProps.edge || this.props.origin !== nextProps.origin || this.props.dest !== nextProps.dest;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props$edge = this.props.edge,
                output = _props$edge.output,
                input = _props$edge.input,
                color = _props$edge.color;

            var from = this.props.origin;
            var to = this.props.dest;

            var start = {
                x: from.x + from.width,
                y: from.y + from.minPin + (output + 0.5) * from.pinHeight
            };
            var end = {
                x: to.x,
                y: to.y + to.minPin + (input + 0.5) * to.pinHeight
            };
            var delta = {
                x: end.x - start.x,
                y: end.y - start.y
            };

            var goingForward = delta.x >= 0.0;
            var tension = {
                x: Math.min(Math.abs(delta.x), goingForward ? 1000 : 200),
                y: Math.min(Math.abs(delta.y), goingForward ? 1000 : 200)
            };

            var tangent = goingForward ? {
                x: (tension.x + tension.y) * 0.5,
                y: 0
            } : {
                x: tension.x * 1.5 + tension.y * 0.75,
                y: 0
            };

            return _react2.default.createElement('path', {
                fill: 'none',
                stroke: color,
                d: '\n                    M' + start.x + ' ' + start.y + '\n                    C' + (start.x + tangent.x) + ' ' + (start.y + tangent.y) + ',\n                     ' + (end.x - tangent.x) + ' ' + (end.y - tangent.y) + ',\n                     ' + end.x + ' ' + end.y + '\n                 ' });
        }
    }]);

    return Edge;
}(_react.Component);

exports.default = Edge;