'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _edge = require('./edge');

var _edge2 = _interopRequireDefault(_edge);

var _state = require('./state');

var _graph = require('./graph.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-next-line no-duplicate-imports


function NOOP() {}

var raf = (window ? window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.msRequestAnimationFrame : null) || function (cb) {
    return setTimeout(cb, 16);
};

var Graph = function (_Component) {
    _inherits(Graph, _Component);

    function Graph(props) {
        _classCallCheck(this, Graph);

        var _this = _possibleConstructorReturn(this, (Graph.__proto__ || Object.getPrototypeOf(Graph)).call(this, props));

        _this.__actionQueue = new _immutable.List();

        _this.mouseDown = function (evt) {
            evt.preventDefault();

            if (_this.__graph) {
                var _nextState = _this.props.value;
                if (evt.target === _this.__graph) {
                    _nextState = _nextState.closeMenu();
                }

                var _this$getGraphCoords = _this.getGraphCoords(evt),
                    _x = _this$getGraphCoords.x,
                    _y = _this$getGraphCoords.y;

                _this.props.onChange(_nextState._startMouse(_x, _y));
            }
        };

        _this.mouseMove = function (evt) {
            if (_this.__graph && _this.props.value.mouseState.down) {
                evt.preventDefault();
                evt.stopPropagation();

                var _this$getGraphCoords2 = _this.getGraphCoords(evt),
                    _x2 = _this$getGraphCoords2.x,
                    _y2 = _this$getGraphCoords2.y;

                _this.props.onChange(_this.props.value._updateMouse(_x2, _y2));
            }
        };

        _this.mouseUp = function (evt) {
            if (_this.props.value.mouseState.down) {
                evt.preventDefault();
                evt.stopPropagation();

                var _nextState2 = _this.props.value._endMouse();
                if (_this.props.value.mouseState.draggingEdge) {
                    var _this$getGraphCoords3 = _this.getGraphCoords(evt),
                        _x3 = _this$getGraphCoords3.x,
                        _y3 = _this$getGraphCoords3.y;

                    _nextState2 = _nextState2.openMenu(_x3, _y3);
                }

                _this.props.onChange(_nextState2);
            }
        };

        _this.contextMenu = function (evt) {
            evt.preventDefault();

            var _this$getGraphCoords4 = _this.getGraphCoords(evt),
                x = _this$getGraphCoords4.x,
                y = _this$getGraphCoords4.y;

            _this.props.onChange(_this.props.value.openMenu(x, y));
        };

        _this.updateSVG = function (svg) {
            if (svg) {
                var bbox = svg.getBBox();
                svg.setAttribute('width', bbox.x + bbox.width + 'px');
                svg.setAttribute('height', bbox.y + bbox.height + 'px');

                _this.__svg = svg;
            }
        };

        _this.measureNode = function (id, width, height) {
            _this.batchAction({
                method: '_measureNode',
                args: [id, width, height]
            });
        };

        _this.measurePin = function (id, y, height) {
            _this.batchAction({
                method: '_measurePin',
                args: [id, y, height]
            });
        };

        _this.clickNode = function (id, evt) {
            if (!_this.isSelected(id)) {
                _this.props.onChange(_this.props.value.selectNode(id, evt.ctrlKey));
            }
        };

        _this.moveNode = function (id, x, y) {
            var final = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

            _this.props.onChange(_this.props.value.moveNode(id, x, y, final));
        };

        _this.dragPin = function (node, pin, evt) {
            if (_this.__graph) {
                evt.preventDefault();
                evt.stopPropagation();

                var _this$getGraphCoords5 = _this.getGraphCoords(evt),
                    _x5 = _this$getGraphCoords5.x,
                    _y4 = _this$getGraphCoords5.y;

                _this.props.onChange(_this.props.value._startMouse(_x5, _y4)._startConnection(node, pin));
            }
        };

        _this.dropPin = function (node, pin, evt) {
            evt.preventDefault();
            evt.stopPropagation();

            _this.props.onChange(_this.props.value._endConnection(node, pin));
        };
        return _this;
    }

    _createClass(Graph, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this.updateSVG(this.__svg);
        }
    }, {
        key: 'getGraphCoords',
        value: function getGraphCoords(evt) {
            return {
                x: evt.clientX + this.__graph.scrollLeft,
                y: evt.clientY + this.__graph.scrollTop
            };
        }
    }, {
        key: 'isSelected',
        value: function isSelected(node) {
            return this.props.value.isSelected(node);
        }
    }, {
        key: 'batchAction',
        value: function batchAction(action) {
            var _this2 = this;

            if (this.__actionQueue.isEmpty()) {
                raf(function () {
                    var currentQueue = _this2.__actionQueue;
                    _this2.__actionQueue = _this2.__actionQueue.clear();

                    _this2.props.onChange(currentQueue.reduce(function (state, item) {
                        return state[item.method].apply(state, _toConsumableArray(item.args));
                    }, _this2.props.value));
                });
            }

            this.__actionQueue = this.__actionQueue.push(action);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props = this.props,
                nodeClass = _props.nodeClass,
                pinClass = _props.pinClass,
                MenuClass = _props.menuClass,
                className = _props.className;
            var _props$value = this.props.value,
                editorState = _props$value.editorState,
                mouseState = _props$value.mouseState,
                menuState = _props$value.menuState;
            var nodes = editorState.nodes,
                edges = editorState.edges;


            var dragLine = function dragLine() {
                if (!mouseState.down) {
                    return null;
                }

                if (mouseState.draggingEdge) {
                    return _react2.default.createElement(_edge2.default, { origin: nodes.get(mouseState.node), dest: new _state.Node({
                            x: mouseState.x,
                            y: mouseState.y,
                            minPin: 0
                        }), edge: {
                            output: mouseState.pin,
                            input: 0,
                            color: '#fff'
                        } });
                }

                var _mouseState$rect = mouseState.rect,
                    minX = _mouseState$rect.minX,
                    minY = _mouseState$rect.minY,
                    maxX = _mouseState$rect.maxX,
                    maxY = _mouseState$rect.maxY;


                return _react2.default.createElement('rect', {
                    x: minX, y: minY,
                    width: maxX - minX,
                    height: maxY - minY });
            };

            return _react2.default.createElement(
                'div',
                {
                    className: _graph.graph + ' ' + className,
                    onMouseDown: this.mouseDown,
                    onMouseMove: this.mouseMove,
                    onMouseUp: this.mouseUp,
                    onContextMenu: this.contextMenu,
                    ref: function ref(elem) {
                        _this3.__graph = elem;
                    } },
                _react2.default.createElement(
                    'svg',
                    { ref: this.updateSVG },
                    edges.map(function (edge) {
                        var from = nodes.get(edge.from);
                        var to = nodes.get(edge.to);

                        return from && to && _react2.default.createElement(_edge2.default, {
                            key: from.id + ':' + edge.output + '-' + to.id + ':' + edge.input,
                            origin: from, dest: to,
                            edge: edge });
                    }),
                    dragLine
                ),
                nodes.map(function (node) {
                    return _react2.default.createElement(_node2.default, { key: node.id, node: node,
                        nodeClass: nodeClass,
                        pinClass: pinClass,
                        measureNode: _this3.measureNode,
                        measurePin: _this3.measurePin,
                        moveNode: _this3.moveNode,
                        mouseDown: _this3.clickNode,
                        dragPin: mouseState.draggingEdge ? NOOP : _this3.dragPin,
                        dropPin: mouseState.draggingEdge ? _this3.dropPin : NOOP,
                        selected: _this3.isSelected(node.id) });
                }).toArray(),
                MenuClass && menuState.open && _react2.default.createElement(MenuClass, { menu: menuState })
            );
        }
    }]);

    return Graph;
}(_react.Component);

exports.default = Graph;