'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMeasure = require('react-measure');

var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

var _pin = require('./pin');

var _pin2 = _interopRequireDefault(_pin);

var _node = require('./node.css');

var _node2 = _interopRequireDefault(_node);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function NOOP() {}

var Node = function (_Component) {
    _inherits(Node, _Component);

    function Node(props) {
        _classCallCheck(this, Node);

        var _this = _possibleConstructorReturn(this, (Node.__proto__ || Object.getPrototypeOf(Node)).call(this, props));

        _this.mouseDown = function (evt) {
            evt.preventDefault();
            evt.stopPropagation();

            _this.__nodeStartX = _this.props.node.x;
            _this.__nodeStartY = _this.props.node.y;
            _this.__mouseStartX = evt.clientX;
            _this.__mouseStartY = evt.clientY;

            window.addEventListener('mousemove', _this.mouseMove);
            window.addEventListener('mouseup', _this.mouseUp);

            _this.props.mouseDown(_this.props.node.id, evt);
        };

        _this.mouseMove = function (evt) {
            evt.preventDefault();

            _this.props.moveNode(_this.props.node.id, _this.__nodeStartX + (evt.clientX - _this.__mouseStartX), _this.__nodeStartY + (evt.clientY - _this.__mouseStartY));
        };

        _this.mouseUp = function (evt) {
            evt.preventDefault();

            _this.props.moveNode(_this.props.node.id, _this.__nodeStartX + (evt.clientX - _this.__mouseStartX), _this.__nodeStartY + (evt.clientY - _this.__mouseStartY), true);

            window.removeEventListener('mousemove', _this.mouseMove);
            window.removeEventListener('mouseup', _this.mouseUp);
        };

        _this.measureNode = function (rect) {
            _this.props.measureNode(_this.props.node.id, rect.width, rect.height);
        };

        _this.measurePin = function (y, height) {
            _this.props.measurePin(_this.props.node.id, y, height);
        };

        _this.dragPin = function (pin, evt) {
            _this.props.dragPin(_this.props.node, pin, evt);
        };

        _this.dropPin = function (pin, evt) {
            _this.props.dropPin(_this.props.node, pin, evt);
        };
        return _this;
    }

    _createClass(Node, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            return this.props.node !== nextProps.node || this.props.dropPin !== nextProps.dropPin || this.props.selected !== nextProps.selected;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('mousemove', this.mouseMove);
            window.removeEventListener('mouseup', this.mouseUp);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var NodeClass = this.props.nodeClass;

            return _react2.default.createElement(
                _reactMeasure2.default,
                { whiteList: ['width', 'height'], onMeasure: this.measureNode },
                _react2.default.createElement(
                    'div',
                    { className: _node2.default.node, onMouseDown: this.mouseDown, style: {
                            transform: 'translate(' + this.props.node.x + 'px, ' + this.props.node.y + 'px)'
                        } },
                    _react2.default.createElement(NodeClass, {
                        node: this.props.node,
                        selected: this.props.selected,
                        inputs: this.props.node.inputs.map(function (pin) {
                            return _react2.default.createElement(_pin2.default, { key: pin.name, pin: pin,
                                pinClass: _this2.props.pinClass,
                                onDrag: NOOP, onDrop: _this2.dropPin,
                                shouldMeasure: _this2.props.node.height > 0,
                                onMeasure: _this2.measurePin });
                        }),
                        outputs: this.props.node.outputs.map(function (pin) {
                            return _react2.default.createElement(_pin2.default, { key: pin.name, pin: pin,
                                pinClass: _this2.props.pinClass,
                                onDrop: NOOP, onDrag: _this2.dragPin,
                                shouldMeasure: _this2.props.node.height > 0,
                                onMeasure: _this2.measurePin });
                        }) })
                )
            );
        }
    }]);

    return Node;
}(_react.Component);

exports.default = Node;